program Term;
{*********************************************************************
* :
*      TERM- H ("DUMB")
* :
*     term [[Speed[⭮[[]]]]
*          - p p.  㬮砭 1.
*      - ᫮  50  115200.  㬮砭 2400
* H     -   ᨬ N,O,E,M  S, 
*                N -  ⮫ (NONE)
*                O - 㬬  ⭠ (ODD)
*                E - 㬬  ⭠ (EVEN)
*                M -  7 ᥣ 1 (MARK)
*                S -  7 ᥣ 0 (SPACE)
*                 㬮砭 p  ⭮ .
*         - ᫮ 䮬樮   .  㬮砭 8.
*          - ᫮ ⮯ , 1  2.  㬮砭 1.
*
**********************************************************************}

uses Crt, WinDos;

const
  USAGE='term [port [speed [parity [word [stop]]]]';

{ ᬥ饭 p⮢ ⭮⥫쭮  }
  LCR=3;   { pp p         }
  MCR=4;   { pp p        }
  LSR=5;   { pp              }
  IER=1;   { pp 䨪樨 pp뢠 }

{ ᪨  ⠭   pp }
  GPO2=8;  { ᨣ pp襭 p pp뢠
              奬 RS-232C                         }
  R_INT=1; { H      }

{ HH, H  H H 8259    }
  IMR=$21;  {    H      }
  ICR=$20;  {   H                }
  IRQ3=$f7; {   H H  2 }
  IRQ4=$ef; {   H H  1 }
  EOI3=$63; { H  HH  H  2 }
  EOI4=$64; { -----//-----//-------//------//------//---- 1 }

{   H    H  }
  DTR=1;    { H H H       }
  RTS=2;    { H  H         }

  TRRDY=$20; {   H H 
                                         }
  BSIZE=4096;{                           }
  inptr:word=1; {  H 1- H    }
  outptr:word=1;{  H 1-           }

  ESC=$1b;  { ASCII   ESC             }

var
{ H HH }
  p_base:integer;   {      H  }
  old_int:pointer;  {     H  H        }
  eoi:integer;      { H  HH  H }

  buf:array[1..BSIZE] of byte; {                 }
  _port:integer;                { H                    }
  speed:longint;               {  H               }
  parity:char;                 { H  H          }
  _word:integer;               {  HHH       }
  stop:integer;                {               }
  ch:byte;                     {  HH            }
  in_char:char;
  i, j:integer;                {  HH            }
{  prog_str:PChar; }

{**************************************************************************
*  new_int   H  .
* H  H  HHH H,
*          .
**************************************************************************}
procedure new_int; interrupt;
begin
  buf[inptr]:=port[p_base];  {   }

  inc(inptr);
  if (inptr>BSIZE) then  {   H  }
    inptr:=1;            { HH H }

  port[ICR]:=eoi;  { H  H 8259  HH 
                     H   }
end;

{************************************************************************
* H PORTBASE    HH   
* H HH BIOS  H H HH p_base.
*
*  HH p_base  -1     .
*************************************************************************}
function portbase(pnum:word):integer;
begin
  p_base:=memw[$40:pnum];   {    }
  if p_base=0 then
    portbase:=-1
  else
    portbase:=p_base;
end;

{***********************************************************************
*  SETPARM H  H:
* ,  H  H,   HH    
***********************************************************************}
procedure setparm(baud:longint; parity:char; _word, stop:integer);
var
  divisor:longint; {    H 
                              H  H     }
  parm:byte;    {    
                                H H }
begin
  if p_base=0 then   { 0 H ,    H HH }
    exit;
  parm:=Port[p_base + LCR]; { H   H }
{ H  H }
{  = 1.8432  / (baud*16) }
  divisor:=115200 div baud;
  port[p_base + LCR]:=(parm or $80); {    H 
                                    H. DLAB  1                      }
  port[p_base + 1]:=(divisor shr 8);  {        }
  port[p_base]:=(divisor and $ff);   {        }

{      H H }
{ H }
  parm:=parm and 7;     {  H NONE }
  case parity of
    'S', 's': parm:=parm or (7 shl 3); { space }
    'M', 'm': parm:=parm or (5 shl 3); { mark }
    'E', 'e': parm:=parm or (3 shl 3); { even }
    'O', 'o': parm:=parm or (1 shl 3); { odd }
  end;

{ H   HH      }
  parm:=parm or (((stop - 1) shl 2) or (_word - 5));
{ H  H  H DLAB }
  port[p_base + LCR]:=parm;
end;

{*******************************************************************
*  PORTON     H.
* H  H,  H   
*  H H H   H .
*******************************************************************}
procedure porton(pnum:integer);
var
  i_num:word;       { H H }
  c:integer;
begin
  if ((pnum = 2) or (pnum = 4)) then    { H H H }
    i_num:=$b
  else
    i_num:=$c;
  GetIntVec(i_num, old_int);
  SetIntVec(i_num, @new_int);    { H  H }

{ H H OUT2, DTR  RTS }
  c:=port[p_base + MCR] or GPO2 or DTR or RTS;
  port[p_base + MCR]:=c;
{ H     }
  port[p_base + IER]:=R_INT;

{ H H 8259 }
  c:=port[IMR];
  if ((pnum=2) or (pnum=4)) then
    begin
      c:=c and IRQ3;     { H H    2  }
      eoi:=EOI3;  { H  HH  H   2 }
    end
  else
    begin
      c:=c and IRQ4;     { H ----//---//----//---- 1 }
      eoi:=EOI4;  { H ---//-----//----//-----//-----//-----//--- 1 }
    end;
  port[IMR]:=c;
end;

{*****************************************************************************
*  PORTOFF, H  PORTON.
*  H  , H 
* H   H  H .
*****************************************************************************}
procedure portoff(pnum:integer);
var
  i_num:word;
  c:integer;
begin
{ H H 8259 }
  c:=port[IMR];
  if ((pnum=2) or (pnum=4)) then
    c:=c or (not IRQ3)    {  IRQ3 }
  else
    c:=c or (not IRQ4);   { ----//---- IRQ4 }
  port[IMR]:=c;

  port[p_base+IER]:=0;   { H H H }
  port[p_base+MCR]:=0;   {  H              }

{ H H H }
  if ((pnum=2) or (pnum=4)) then
    i_num:=$b
  else
    i_num:=$c;
  SetIntVec(i_num,old_int);
end;

{*************************************************************************
* H PORTIN  H    . 
*  ,   -1
*************************************************************************}
function portin(var ch:byte):boolean;
begin
  if (inptr<>outptr) then  {    HH? }
    begin
      ch:=buf[outptr] and $7f;   { ,  FSCII  }
      inc(outptr);
      if (outptr>BSIZE) then
        outptr:=1;       {  HH H  }
      portin:=true;
      exit;
    end;
  portin:=false;
end;

{************************************************************************
* H PORTOUT   ch  H.  0 
* HH H.    -1
************************************************************************}
function portout(ch:byte):boolean;
var
  tm:integer;
begin
  tm:=-32000;   {   H - }
  while ((port[p_base + LSR] and TRRDY)=0) do {  H   }
    begin
      if tm>0 then
        begin
          portout:=false;        { timeout }
          exit;
        end;
      inc(tm);
    end;
  port[p_base]:=ch;    {   }
  portout:=true;
end;

begin
  _port:=1;            { H               }
  speed:=2400;         {  H          }
  parity:='N';         { H  H     }
  _word:=8;            {  HHH  }
  stop:=1;             {          }

  if ParamCount>5 then
    begin
      writeln;
      writeln(USAGE);
      writeln;
      exit;
    end;

  if ParamCount>0 then  { H               }
    begin
      val(ParamStr(1), _port, i);
      if i<>0 then
        _port:=1;
    end;

  if ParamCount>1 then  {  H          }
    begin
      val(ParamStr(2), speed, i);
      if i<>0 then
        speed:=2400;
    end;

  if ParamCount>2 then  { H  H     }
    begin
      val(ParamStr(3), j, i);
      if i<>0 then
        parity:='N'
      else
        parity:=UpCase(char(j));
    end;

  if ParamCount>3 then {  HHH  }
    begin
      val(ParamStr(4), _word, i);
      if i<>0 then
        _word:=8;
    end;

  if ParamCount>4 then {          }
    begin
      val(ParamStr(5), stop, i);
      if i<>0 then
        stop:=1;
    end;

  if (_port<1) or (_port>4) then      {  H  }
    begin
      writeln;
      writeln('HH H !');
      writeln(USAGE);
      exit;
    end;

  if (speed<50) or (speed>115200) then {   H }
    begin
      writeln;
      writeln('HH H !');
      writeln(USAGE);
      exit;
    end;

  if (_word>8) or (_word<5) then       {   HHH  }
    begin
      writeln;
      writeln('HH H  !');
      writeln(USAGE);
      exit;
    end;
                                       { H  H     }
  if (parity<>'N') and (parity<>'O') and (parity<>'M') and (parity<>'S')
    and (parity<>'E') then
      begin
        writeln;
        writeln('HH H H!');
        writeln(USAGE);
        exit;
      end;

  if (stop>2) or (stop<1) then     {           }
    begin
      writeln;
      writeln('HH H  !');
      writeln(USAGE);
      exit;
    end;

{ H   H  }
  if portbase(_port)=-1 then
    begin
      writeln;
      writeln(' ', _port, '  H  H!');
      exit;
    end;

{ H  H  H  }
  setparm(speed,parity,_word,stop);

{     }
  porton(_port);
  writeln;
  writeln(' COM', _port, '  ', speed);
  writeln('  H ESC');

{****  HH   ****}
  while true do
    begin
      if portin(ch)=true then     {  HH  ? }
        Write(ch);                {  H H   }
      if KeyPressed=true then
        begin
          in_char:=ReadKey;
          write(in_char);
          if in_char<>char(ESC) then      {  ?    }
            portout(byte(in_char))        { H.   H }
          else
            break;                        { . H             }
        end;
    end;
{ H   H H }
  portoff(_port);
end.

